﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Windows.Forms;
using HeuristicLab.Core;

namespace HeuristicLab.Problems.MetaOptimization.Views {
  public partial class CreateExperimentDialog : Form {

    public bool CreateBatchRuns {
      get { return createBatchRunCheckBox.Checked; }
    }
    public int Repetitions {
      get { return (int)repetitionsNumericUpDown.Value; }
    }
    public IEngine Engine {
      get { return (IEngine)engineComboBox.SelectedItem; }
    }

    public CreateExperimentDialog(IEnumerable<IEngine> engines, Type selectedEngine) {
      InitializeComponent();
      foreach (var engine in engines) {
        this.engineComboBox.Items.Add(engine);
        if (engine.GetType() == selectedEngine) {
          this.engineComboBox.SelectedItem = engine;
        }
        if (this.engineComboBox.SelectedItem == null) {
          this.engineComboBox.SelectedIndex = 0;
        }
      }
    }

    private void createBatchRunCheckBox_CheckedChanged(object sender, EventArgs e) {
      repetitionsNumericUpDown.Enabled = createBatchRunCheckBox.Checked;
    }
    private void repetitionsNumericUpDown_Validated(object sender, EventArgs e) {
      if (repetitionsNumericUpDown.Text == string.Empty)
        repetitionsNumericUpDown.Text = repetitionsNumericUpDown.Value.ToString();
    }
    private void okButton_Click(object sender, EventArgs e) {
      this.Close();
    }
  }
}
